Page MenuHomePhabricator

[STORY] MUL - Add link to help page about “multiple languages” in the desktop termbox in editing mode
Closed, ResolvedPublic13 Estimated Story Points

Description

Problem:
When we introduce mul Labels and Aliases, this language code will work a bit differently to other language codes. Using it requires additional knowledge from guidelines and help pages. In its current form, this is not self-explanatory to users.

Solution:

  • Add an onboarding element to the termbox that allows users to access to further information about the Multiple languages functionality. This will be in the shape of a tooltip/popover with a link that leads to the most relevant help page explaining mul. The tooltip also contains a checkbox by which users can make it to not show again.
  • The onboarding element should only be visible in the "edit" view of the termbox, and not in the "reading" view.
  • The link target is https://www.wikidata.org/wiki/Special:MyLanguage/Help:Mul

Mockups:

Screenshot 2023-06-08 at 15.11.49.png (681×1 px, 175 KB)

BDD:

Show pulsating dot.

GIVEN an Item or Property
WHEN users try to edit the entity's label, description or aliases
AND the user has not dismissed the message before ("Do not show this again")
THEN an onboarding pulsating dot is shown in the termbox

Open the help popover.

GIVEN a user try to edit the entity's label, description or aliases
WHEN an onboarding pulsating dot is shown in the termbox
AND the pulsating dot is clicked
THEN a tooltip with further information is displayed

Dismissing the popover.

GIVEN that an onboarding tooltip with further information about Multiple languages is displayed
WHEN the user checks the "Don't show this again" input inside the popover
AND the user closes the popover or clicks away
THEN Neither the pulsating dot nor the popover will be displayed again

Acceptance criteria:

  • An onboarding element is visible in the termbox when editing an entity on desktop (or if solving this is out of scope, then please discuss with @Manuel ).
  • Once the onboarding element is clicked, it opens a popup with extra information and a link to the help page.
  • The onboarding element is only visible to logged-in users.
  • Users can hide the onboarding element by checking the "don't show this again" checkbox.
  • Release to test.wikidata.org

Notes:

  • After the community feels ready, we will deactivate this onboarding feature for good.
  • To implement the pulsating dot, we could reuse (or copy) mediawiki.pulsatingdot.less. We need to align on what would be less costly.
  • Related to the point above: We'd like to reduce the iteration count of the pulsating dot animation to 3 times, in order to reduce distractions.

Related Objects

Event Timeline

Manuel renamed this task from Add link to help page in termbox for “multiple languages” to MUL - Add link to help page in termbox for “multiple languages”.Oct 28 2022, 3:24 PM
Manuel moved this task from Ready for story writing to Task with Epic on the Wikidata-Campsite board.
Manuel renamed this task from MUL - Add link to help page in termbox for “multiple languages” to MUL - Add link to help page in termbox about “multiple languages”.Feb 14 2023, 2:58 PM
Manuel updated the task description. (Show Details)
Manuel updated the task description. (Show Details)
Manuel renamed this task from MUL - Add link to help page in termbox about “multiple languages” to MUL - Add link to help page about “multiple languages” in desktop termbox .Mar 15 2023, 2:18 PM
Manuel updated the task description. (Show Details)

Hi @Sarai-WMDE, thank you for your update! Based on the description, the "pulsating onboarding dot" would be always active. This seems a bit much, don't you think? My preference would be something like it is now described in the BDD (a help icon that you need to interact with). What do you think?

Thanks for the feedback, @Manuel! I was actually planning to reach out to you about this. With "always active", are you referring to the pulsating animation? We can define how many iterations we want the animation to have. For example, it could only pulsate twice, then become idle. The popover is only displayed on hover. It's very similar to the icon in that sense, but if you're concerned about potentially creating a distraction (very valid point) we could definitely go for the static icon.

There are a couple of things that I'm still trying to figure out (reached out to WMF) and would love to hear your opinion about:

  1. I'm assuming that the icon will be visible in the termbox on edit mode for all users regardless of their log in status: is that correct?
  1. Which factor(s) do you think should determine the disappearance of the icon? External time (e.g. display the onboarding icon consistently for a predetermined duration), number of visualizations (e.g. logged-in users only see the icon after enabling edit mode once), user preference (offer users the option to dismiss the onboarding icon permanently through a "don't show this again" checkbox inside the popover)? I might be inclined to combine external time (display the icon to every one for a number of weeks) with user preference (users can still dismiss the onboarding element at any point), but would like to know your thoughts.

Thank you!

Thank you again for the explanations and our discussion today, @Sarai-WMDE! Convincing and looks great! Is it easy to also update the png or should I just add a screenshot?

Manuel updated the task description. (Show Details)

Sprint Planning Notes:

  • There is some system to keep user preferences reagrding UI (e.g. The collpase state of the termbox itself and the copyright notice. See: https://gerrit.wikimedia.org/g/mediawiki/extensions/Wikibase/+/8009f2f93f06f35f0bed41008fdf7e546818dc07/repo/resources/wikibase.ui.entityViewInit.js#274)
  • The final copy of the message might change, continue with the current copy, but make sure to verify with product before merging
  • The reasoning to keep the help URL as an interface message, and thus also a localizable string, is to enable on wiki editors to determine the end URL for their own wiki (e.g. wikidata editors could decide where the wikidata help page goes).
  • @Manuel will confirm with the other PMs whether this is needed for Wikidata alone (in which case we don't necessarily need to take extra care about the HELP URL and other configurable elements, since we will remove the code at the end of this onboarding period)
ItamarWMDE set the point value for this task to 13.Jun 13 2023, 10:50 AM
Sarai-WMDE removed the point value for this task.
ItamarWMDE set the point value for this task to 13.Jun 22 2023, 12:12 PM

Task breakdown notes:

  • We only want to add this on the JS side, not the PHP side (no-JS users couldn’t do anything with the pulsating dot anyways).
  • To find the code responsible for the language name field in the termbox, codesearch for wikibase-entitytermsforlanguageview-language (the CSS class name).
  • To find out how to use the pulsatingdot styles linked in the task description, codesearch pulsatingdot
  • For some existing Wikibase-ish code adding a similar popup, see WikibaseQualityConstraints and maybe also Tainted References. (But Tainted References is implemented using Vue, and we probably want jQuery / OOUI here, so WikibaseQualityConstraints might be more useful.)
  • See the sprint planning notes (T316769#8927033) for how to implement the option to remember “don’t know this again”.
  • The default value of the link target (to be customized via the MediaWiki: namespace on Wikidata) should not be in en.json, but rather in the PHP or JS code, so that the language fallback works how we want – see T313599 (especially T313599#8224887), where we had issues with another thing that we also wanted to be configurable via i18n messages.
  • To limit the number of iterations of the pulsating dot, we probably override the animation-iteration-count: infinite; via CSS.
  • We’re first implementing the popup (T340643), then the “don’t show this again” option (T340644).
Manuel updated the task description. (Show Details)

Change 939729 had a related patch set uploaded (by Lucas Werkmeister (WMDE); author: Lucas Werkmeister (WMDE)):

[mediawiki/extensions/Wikibase@master] Don’t add multiple pulsating dots

https://gerrit.wikimedia.org/r/939729

Manuel renamed this task from MUL - Add link to help page about “multiple languages” in desktop termbox to [STORY] MUL - Add link to help page about “multiple languages” in desktop termbox .Jul 19 2023, 5:34 PM

Change 939729 merged by jenkins-bot:

[mediawiki/extensions/Wikibase@master] Don’t add multiple pulsating dots

https://gerrit.wikimedia.org/r/939729

Manuel renamed this task from [STORY] MUL - Add link to help page about “multiple languages” in desktop termbox to [STORY] MUL - Add link to help page about “multiple languages” in the desktop termbox in editing mode.Jul 21 2023, 4:16 PM
Manuel updated the task description. (Show Details)
Manuel claimed this task.
Manuel updated the task description. (Show Details)

It's looking great, thank you! All acceptance criteria verified! \o/